<?php

namespace Ems\portalGestor\Service;

use Ems\portalGestor\Util\HcmServices;

class HierarquiaService {

    /** @var HcmServices $hcmServices */
    public $hcmSevices;

    public function __construct(HcmServices $hcmServices) {
        $this->hcmServices = $hcmServices;
    }

    public function getTiposHierarquia(
        int $nrOrg
    ): array {
        $route = 'getTiposHierarquia';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'EMPTY' => null,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $tiposHierarquia = $result['dataset'][$route];

        return $tiposHierarquia;
    }

    public function getHierarquiaOrganizacao(
        int $nrOrg,
        int $nrVinculo
    ): array {
        $route = 'getHierarquiaOrganizacao';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRVINCULOM' => $nrVinculo,
            ],
        ];

        $result = $this->hcmServices->send($route, $params, $nrOrg);
        $hierarquia = $result['dataset'][$route];

        return $hierarquia;
    }
}