/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TPRA                                                     */
/* Tabela : TIPOPRAT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TPRA
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOPRAT FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPRA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOPRAT,0) <> NVL(:NEW.CDTIPOPRAT,0)) OR
         (NVL(:OLD.NMTIPOPRAT,0) <> NVL(:NEW.NMTIPOPRAT,0)) THEN
         :NEW.DTULTATUTPRA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOPRAT', '', 'CDTIPOPRAT='||:OLD.CDTIPOPRAT||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOPRAT MODIFY DTULTATUTPRA DEFAULT SYSDATE
/
