/*
-- =====================================================================
-- CUSTOCIA - Custo de Comapnhia
-- =====================================================================
*/
CREATE OR REPLACE PROCEDURE CUSTOCIA(
P_IDINSERES  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Servio; 'N' - No Insere Servio.
P_IDINSEREP  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Produto; 'N' - No Insere Produto; 'P' - Insere Somente os Produtos Principais.
P_IDINSERER  IN VARCHAR DEFAULT 'N', -- 'S' - Insere Receita; 'N' - No Insere Receita; 'P' - Insere Somente as Receitas Principais.
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_CDCIA      IN COMPANHIA.CDCIA%TYPE,
P_DTCUSTO    IN DATE,
P_CDOPERADOR IN OPERADOR.CDOPERADOR%TYPE,

CDSEQCUSCIA OUT CUSTOSEMA.CDSEQCUSSE%TYPE,

VRCUSULCLIQCIA OUT NUMBER,
VRCUSULCBRUCIA OUT NUMBER,
VRCUSMEDLIQCIA OUT NUMBER,
VRCUSMEDBRUCIA OUT NUMBER
) AS
V_CDSEQITEM  NUMBER(10);

V_CUSULCLIQMAN NUMBER;
V_CUSULCBRUMAN NUMBER;
V_CUSMEDLIQMAN NUMBER;
V_CUSMEDBRUMAN NUMBER;

V_CUSULCLIQCIAT NUMBER;
V_CUSULCBRUCIAT NUMBER;
V_CUSMEDLIQCIAT NUMBER;
V_CUSMEDBRUCIAT NUMBER;

V_CDSEQCUSCIA CUSTOSEMA.CDSEQCUSSE%TYPE;

BEGIN
	V_CDSEQCUSCIA   := '0000000000';
   V_CDSEQITEM     := 0;
   V_CUSULCLIQCIAT := 0;
   V_CUSULCBRUCIAT := 0;
   V_CUSMEDLIQCIAT := 0;
   V_CUSMEDBRUCIAT := 0;

	FOR C_MAN IN(
   SELECT CDMANCIA
   FROM MANUALCIA
   WHERE (CDFILIAL = P_CDFILIAL) AND
         (CDCIA    = P_CDCIA   )) LOOP

      CUSTOMAN(V_CDSEQCUSCIA,'M',V_CDSEQITEM,P_IDINSERES,P_IDINSEREP,
               P_IDINSERER,P_CDFILIAL,P_CDCIA,C_MAN.CDMANCIA,NULL,
               P_DTCUSTO,P_CDOPERADOR,V_CUSULCLIQMAN,V_CUSULCBRUMAN,
               V_CUSMEDLIQMAN,V_CUSMEDBRUMAN);

      V_CUSULCLIQCIAT := V_CUSULCLIQCIAT + V_CUSULCLIQMAN;
      V_CUSULCBRUCIAT := V_CUSULCBRUCIAT + V_CUSULCBRUMAN;
      V_CUSMEDLIQCIAT := V_CUSMEDLIQCIAT + V_CUSMEDLIQMAN;
      V_CUSMEDBRUCIAT := V_CUSMEDBRUCIAT + V_CUSMEDBRUMAN;
   END LOOP;

   CDSEQCUSCIA    := V_CDSEQCUSCIA;
   VRCUSULCLIQCIA := V_CUSULCLIQCIAT;
   VRCUSULCBRUCIA := V_CUSULCBRUCIAT;
   VRCUSMEDLIQCIA := V_CUSMEDLIQCIAT;
   VRCUSMEDBRUCIA := V_CUSMEDBRUCIAT;
END;
/
