/* Sistemas Integrados TEKNISA

Nome: 0002_DATSTPS_GERA_CONSUMIDOR.SQL

C:\Web_530\sql\end_conv\sqlserver\clientes\dat\0002_DATSTPS_GERA_CONSUMIDOR.SQL

Descrio:
Rotina para importao de consumidores dos sistemas SGC e SCP para
o sistema Teknisa.

Criao:
28/04/2010 - Cleison Rafael da Silva Ferreira
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'GERA_CONSUMIDOR' AND
	        TYPE = 'P' 		   AND
	        U.UID = O.UID              AND
	        U.NAME = USER)
DROP PROCEDURE GERA_CONSUMIDOR
GO

CREATE PROCEDURE GERA_CONSUMIDOR @P_SERVIDOR  VARCHAR(50),
                                 @P_USUARIO   VARCHAR(50),
                                 @P_SENHA     VARCHAR(50),
                                 @P_BASE      VARCHAR(50),
                                 @P_RESULT    VARCHAR(01) OUTPUT
AS
   DECLARE @V_CLIENTE        VARCHAR(21);
   DECLARE @V_CDCLIENTE      VARCHAR(10);
   DECLARE @V_CDCONSUMID     VARCHAR(21);
   DECLARE @V_NMCONSUMID     VARCHAR(50);
   DECLARE @V_IDCONSUMID     VARCHAR(01);
   DECLARE @V_CDCENTCUST     VARCHAR(10);
   DECLARE @V_CDTPCONS       VARCHAR(02);
   DECLARE @V_NRCRACHA       VARCHAR(21);
   DECLARE @V_SENHACRACHA    VARCHAR(40);
   DECLARE @V_CDSITE         VARCHAR(30);
   DECLARE @V_SENHASITE      VARCHAR(40);
   DECLARE @V_DTEXPORTACAO   DATETIME;
   DECLARE @V_HREXPORTACAO   VARCHAR(04);
   DECLARE @V_DTIMPORTACAO   DATETIME;
   DECLARE @V_HRIMPORTACAO   VARCHAR(04);
   DECLARE @V_VERIFICA       VARCHAR(30);
   DECLARE @V_LOGERROS       VARCHAR(500);
   DECLARE @V_GRAVAERROS     VARCHAR(500);
   DECLARE @V_CAMINHO        VARCHAR(200);
   DECLARE @V_NOMEARQ        VARCHAR(50);
   DECLARE @V_COMANDO        VARCHAR(500);
   DECLARE @V_RESULT         VARCHAR(01);
BEGIN
   SET @V_RESULT = '0';
   SET @V_GRAVAERROS = '';
/*Declarao do cursor*/
   CREATE TABLE TEMPTXT
   (
      DESCRICAO VARCHAR(100)
   );

   INSERT INTO TEMPTXT VALUES ('Integrao: Teknisa x SGC');
   INSERT INTO TEMPTXT VALUES ('Rotina: Importao de Consumidores');
   INSERT INTO TEMPTXT VALUES ('Inconsistncias geradas na importao de consumidores (SGC e SCP):');

   DECLARE C_CONSUMIDOR CURSOR FOR
      SELECT CDCLIENTE, CDCONSUMID, NMCONSUMID, IDCONSUMID, CDCENTCUST,
             CDTPCONS, NRCRACHA, SENHACRACHA, CDSITE, SENHASITE,
             DTEXPORTACAO, HREXPORTACAO, DTIMPORTACAO, HRIMPORTACAO
        FROM SGC_CONSUMIDOR
       WHERE DTIMPORTACAO IS NULL
         AND HRIMPORTACAO IS NULL
   OPEN C_CONSUMIDOR;
   FETCH NEXT FROM C_CONSUMIDOR INTO @V_CDCLIENTE,    @V_CDCONSUMID,   @V_NMCONSUMID,   @V_IDCONSUMID,  @V_CDCENTCUST,
                                     @V_CDTPCONS,     @V_NRCRACHA,     @V_SENHACRACHA,  @V_CDSITE,      @V_SENHASITE,
                                     @V_DTEXPORTACAO, @V_HREXPORTACAO, @V_DTIMPORTACAO, @V_HRIMPORTACAO;

   WHILE (@@FETCH_STATUS = 0) BEGIN
/*Inicializa a varivel de erros*/
      SET @V_LOGERROS = '';
/*Verifica se existe o cliente informado*/
      SELECT @V_CLIENTE = MAX(CDCLIENTE)
        FROM EXPORTCLIE
       WHERE CDCLIEEXPORT = @V_CDCLIENTE;
/*Se o cliente no existir, grava na varivel de erro*/
      IF @V_CLIENTE IS NULL BEGIN
         SET @V_LOGERROS = 'Cliente '+@V_CDCLIENTE+' no cadastrado.';
         INSERT INTO TEMPTXT VALUES (@V_LOGERROS);
      END;
/*Verifica se existe o tipo de consumidor informado*/
      SELECT @V_VERIFICA = MAX(CDTIPOCONS)
        FROM TIPOCONS
       WHERE CDTIPOCONS = @V_CDTPCONS;
/*Se no existir, grava na varivel de erro*/
      IF @V_VERIFICA IS NULL BEGIN
         SET @V_LOGERROS = 'Tipo de consumidor '+@V_CDTPCONS+' invlido para consumidor'+@V_CDCONSUMID+'.';
         INSERT INTO TEMPTXT VALUES (@V_LOGERROS);
      END;
/*Verifica se o centro de custo est cadastrado para o consumidor*/
      SELECT @V_VERIFICA = MAX(CDCCUSCLIE)
        FROM CCUSCLIE
       WHERE CDCCUSCLIE = @V_CDCENTCUST
         AND CDCLIENTE  = @V_CLIENTE;
/*Se no existir, grava na varivel de erro*/
      IF @V_VERIFICA IS NULL BEGIN
         SET @V_LOGERROS = 'Centro de Custo '+@V_CDCENTCUST+' invlido para consumidor'+@V_CDCONSUMID+'.';
         INSERT INTO TEMPTXT VALUES (@V_LOGERROS);
      END;
/*Verifica se existe o nmero do crach para o cliente informado*/
      SELECT @V_VERIFICA = MAX(CDIDCONSUMID)
        FROM CONSUMIDOR
       WHERE CDCLIENTE = @V_CLIENTE
         AND CDIDCONSUMID = @V_NRCRACHA
         AND @V_IDCONSUMID = '1';
/*Se existir, grava na varivel de erro*/
      IF NOT @V_VERIFICA IS NULL BEGIN
         SET @V_LOGERROS = 'Nmero do crach '+@V_NRCRACHA+' j cadastrado para o cliente'+@V_CDCLIENTE+'.';
         INSERT INTO TEMPTXT VALUES (@V_LOGERROS);
      END;
/*Verifica se existe o cdigo de acesso ao site para o cliente informado*/
      SELECT @V_VERIFICA = MAX(NMLOGINCONS)
        FROM CONSUMIDOR
       WHERE CDCLIENTE = @V_CLIENTE
         AND NMLOGINCONS = ISNULL(@V_CDSITE,@V_NRCRACHA)
         AND @V_IDCONSUMID = '1';
/*Se existir, grava na varivel de erro*/
      IF NOT @V_VERIFICA IS NULL BEGIN
         SET @V_LOGERROS = 'Cdigo de acesso ao site '+@V_NRCRACHA+' j cadastrado para o cliente'+@V_CDCLIENTE+'.';
         INSERT INTO TEMPTXT VALUES (@V_LOGERROS);
      END;
/*Se no existir erro, insere na tabela consumidor*/
      IF @V_LOGERROS = '' BEGIN
         SET @V_RESULT = '1';
         UPDATE CONSUMIDOR
            SET NMCONSUMIDOR = @V_NMCONSUMID,
                IDSITCONSUMI = @V_IDCONSUMID,
                CDTIPOCONS   = @V_CDTPCONS,
                CDCCUSCLIE   = @V_CDCENTCUST,
                CDIDCONSUMID = @V_NRCRACHA,
                CDSENHACONS  = @V_SENHACRACHA,
                NMLOGINCONS  = @V_CDSITE,
                CDSENHASITE  = @V_SENHASITE
          WHERE CDCLIENTE = @V_CLIENTE
            AND CDCONSUMIDOR = @V_CDCONSUMID;

         IF ROWCOUNT_BIG() = 0 BEGIN
           INSERT INTO CONSUMIDOR
               (CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, IDSITCONSUMI, CDTIPOCONS,
                CDCCUSCLIE, CDIDCONSUMID, CDSENHACONS, NMLOGINCONS, CDSENHASITE)
            VALUES
               (@V_CLIENTE, @V_CDCONSUMID, @V_NMCONSUMID, @V_IDCONSUMID, @V_CDTPCONS,
                @V_CDCENTCUST, @V_NRCRACHA, @V_SENHACRACHA, ISNULL(@V_CDSITE,@V_NRCRACHA), @V_SENHASITE);
        END;
      END;
/*Se houver algum erro, grava na varivel de gravao de erros*/
      ELSE BEGIN
         SET @V_GRAVAERROS = @V_LOGERROS;
      END;

      FETCH NEXT FROM C_CONSUMIDOR INTO @V_CDCLIENTE,    @V_CDCONSUMID,   @V_NMCONSUMID,   @V_IDCONSUMID,  @V_CDCENTCUST,
                                        @V_CDTPCONS,     @V_NRCRACHA,     @V_SENHACRACHA,  @V_CDSITE,      @V_SENHASITE,
                                        @V_DTEXPORTACAO, @V_HREXPORTACAO, @V_DTIMPORTACAO, @V_HRIMPORTACAO;

   END;

   CLOSE C_CONSUMIDOR;
   DEALLOCATE C_CONSUMIDOR;
/*Gera arquivo com o log dos erros econtrados*/
   IF NOT (@V_GRAVAERROS = '') BEGIN
      SET @V_RESULT = '2';

      SELECT @V_CAMINHO = DSDIRETORIO
        FROM DIRETORIOS
       WHERE CDPROGRAMA = 'DAT00200';

      IF SUBSTRING(@V_CAMINHO,LEN(@V_CAMINHO),1) <> '/' BEGIN
         SET @V_CAMINHO = @V_CAMINHO+'/';
      END;

      IF @V_CAMINHO IS NOT NULL BEGIN
         SET @V_NOMEARQ  = 'LOG_CONS_'+REPLACE(CONVERT(VARCHAR,GETDATE(),103),'/','')+'_'+REPLACE(CONVERT(VARCHAR,GETDATE(),108),':','')+'.TXT';
         SET @V_COMANDO  = 'sqlcmd -S'+@P_SERVIDOR+' -U'+@P_USUARIO+' -P'+@P_SENHA+' -q "SELECT DESCRICAO AS '+'''Teknisa Sistemas Integrados'''+' FROM '+@P_BASE+'..TEMPTXT" -o"'+@V_CAMINHO+@V_NOMEARQ+'"';
         exec xp_cmdshell @V_COMANDO;
      END;
   END;

   DROP TABLE TEMPTXT;
   SET @P_RESULT = @V_RESULT;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_CONSUMIDOR','5.30.000';
GO
